<?php

namespace Drupal\tmgmt_contentapi\Plugin\views\filter;

use Drupal\views\Plugin\views\display\DisplayPluginBase;
use Drupal\views\Plugin\views\filter\ManyToOne;
use Drupal\views\ViewExecutable;
use Drupal\views\Views;

/**
 * Filters by phase or status of project.
 *
 * @ingroup views_filter_handlers
 *
 * @ViewsFilter("liox_job_status_filter")
 */
class LioxJobstatusFilter extends ManyToOne {

  /**
   * The current display.
   *
   * @var string
   *   The current display of the view.
   */
  protected $currentDisplay;

  //  /**
  //  * Gets the values of the options.
  //  *
  //  * @return array
  //  *   Returns options.
  //  */
  // public function getValueOptions() {
  //   $this->valueOptions = [
  //     '0' => t('Sending'),
  //     '1' => t('Sent to provider'),
  //     '2' => t('In translation'),
  //     '3' => t('Review translation'),
  //     '4' => t('Completed'),
  //     '5' => t('N/A'),
  //     '6' => t('Unprocessed'),
  //   ];
  //   return $this->valueOptions;
  // }

  /**
   * {@inheritdoc}
   */
  public function init(ViewExecutable $view, DisplayPluginBase $display, array &$options = NULL) {
    parent::init($view, $display, $options);
    $this->valueTitle = t('Filter by Status');
    $this->definition['options callback'] = [$this, 'generateOptions'];
    $this->currentDisplay = $view->current_display;
  }

  /**
   * Helper function that generates the options.
   *
   * @return array
   *   An array of states and their ids.
   */
  public function generateOptions() {

    $options = [
      'SENDING' => t('Sending'),
      'SENT_TO_PROVIDER' => t('Sent to provider'),
      'IN_TRANSLATION' => t('In translation'),
      'REVIEW_TRANSLATION' => t('Review translation'),
      'COMPLETED' => t('Completed'),
      'N/A' => t('N/A'),
      // '6' => t('Unprocessed'),
    ];
    return $options;
    // $states = workflow_get_workflow_state_names();
    // You can add your custom code here to add custom labels for state transitions.
    // return $states;
  }

  /**
   * Helper function that builds the query.
   */
  public function query() {
    
      if($this->value[0] == 'N/A')
      {
         //$sub_query1 = "select b.tjid from (select a.tjid, count(mid) as mcount from tmgmt_message a group by a.tjid) as b whereb.mcount = 0";


         //$sub_query2 = \Drupal::database()->select($sub_query1, 'tmgmt_message');
        $sub_query1 = \Drupal::database()->select('tmgmt_message', 'c');
        $sub_query1->addExpression("count(c.mid)", 'mcount');
        $sub_query1->addField('c', 'tjid');
        $sub_query1->groupBy('c.tjid');

        //$sub_query1 = \Drupal::database()->select($sub_query2, 'w');
        $sub_query2 = \Drupal::database()->select($sub_query1, 'a');
        $sub_query2->addField('a', 'tjid');
        $sub_query2->condition('a.mcount', null,'=');
        $sub_query2->groupBy('a.tjid');
      }else{

        //$sub_query1 = \Drupal::database()->select('tmgmt_message', 'c');
        //$sub_query1->addField('c', 'tjid');
        // $sub_query1->addField('c', 'message');
        
        //$sub_query2 = \Drupal::database()->select($sub_query1, 'tmgmt_message');
        $sub_query2 = \Drupal::database()->select('tmgmt_message', 'c');
        $sub_query2->addExpression("MAX(c.mid)", 'mid');
        $sub_query2->addField('c', 'tjid');
        $sub_query2->condition('c.type', 'jobinfo','=');
        $sub_query2->condition('c.message', '%"'.$this->value[0].'"%','LIKE');
        $sub_query2->groupBy('c.tjid');

       

          
     }
     $join_definition = [
      'table formula' => $sub_query2,
      'field' => 'tjid',
      'left_table' => 'tmgmt_job',
      'left_field' => 'tjid',
     'operator' => '=',
      'adjust' => TRUE,
      'type' => 'inner'
    ];
     $join =Views::pluginManager('join')->createInstance('standard', $join_definition);
     $this->query->addRelationship('my_relation', $join, 'tmgmt_job');
    //  $this->query->addWhere($this->options['group'], 'tjid', \Drupal::database()->query($sub_query), 'IN');
         //$this->query->addWhere('tmgmt_job.tjid',  $sub_query1, 'IN');   
     
  }

}